local *

{ :idTweaksUtils, :idTweaksOptions } = _G
{ :Option } = idTweaksOptions
{ :map } = idTweaksUtils.table

class SelectOption extends Option
  new: (module_instance, key, name, description, values = {}, options = {}, default = true) =>
    -- print "SelectOption#new:#{key}"

    super module_instance, key, name, description, values, options, default

    @type = "select"

  get_aceconfig_options: =>
    -- print "SelectOption#get_aceconfig_options:#{@key}"

    output =
      order: @order
      type: @type
      name: @name
      desc: @description
      disabled: @create_disabled!
      hidden: @create_hidden!
      get: @create_get!
      set: @create_set!
      values: @create_values!

    if @create_dialog_control
      output.dialog_control = @create_dialog_control!

    if @num_options > 0
      output.args = map.map ((v) -> v\get_aceconfig_options!), @options

    output

  create_values: =>
    ->
      {}

idTweaksOptions.SelectOption = SelectOption
